--Defines custom worldgen settings

GLOBAL.require("constants")
GLOBAL.require("map/terrain")


local SW_ENABLED = GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC)

local ganjabush_rate = GetModConfigData("ganjabush_rate") -- here we get the config settings to use

--### DS/ROG BIOMES ###--

if GLOBAL.terrain.rooms.CrappyForest then
	GLOBAL.terrain.rooms.CrappyForest.contents.distributeprefabs.ganjabush_small = ganjabush_rate/8
end

if GLOBAL.terrain.rooms.Forest then
	GLOBAL.terrain.rooms.Forest.contents.distributeprefabs.ganjabush_small = ganjabush_rate/10
end

if GLOBAL.terrain.rooms.DeepForest then
	GLOBAL.terrain.rooms.DeepForest.contents.distributeprefabs.ganjabush_small = ganjabush_rate/8
end

if GLOBAL.terrain.rooms.CrappyDeepForest then
	GLOBAL.terrain.rooms.CrappyDeepForest.contents.distributeprefabs.ganjabush_small = ganjabush_rate/8
end

--### SW BIOMES ###--

if GLOBAL.terrain.rooms.NoOxMeadow then
	GLOBAL.terrain.rooms.NoOxMeadow.contents.distributeprefabs.ganjabush_small = ganjabush_rate/26
end
	
if GLOBAL.terrain.rooms.MeadowOxBoon then
	GLOBAL.terrain.rooms.MeadowOxBoon.contents.distributeprefabs.ganjabush_small = ganjabush_rate/42
end

if GLOBAL.terrain.rooms.MeadowFlowery then
	GLOBAL.terrain.rooms.MeadowFlowery.contents.distributeprefabs.ganjabush_small = ganjabush_rate/42
end
	
if GLOBAL.terrain.rooms.MeadowBees then
	GLOBAL.terrain.rooms.MeadowBees.contents.distributeprefabs.ganjabush_small = ganjabush_rate/42
end

if GLOBAL.terrain.rooms.MeadowCarroty then
	GLOBAL.terrain.rooms.MeadowCarroty.contents.distributeprefabs.ganjabush_small = ganjabush_rate/26
end

if GLOBAL.terrain.rooms.MeadowSappy then
	GLOBAL.terrain.rooms.MeadowSappy.contents.distributeprefabs.ganjabush_small = ganjabush_rate/42
end

if GLOBAL.terrain.rooms.MeadowSpider then
	GLOBAL.terrain.rooms.MeadowSpider.contents.distributeprefabs.ganjabush_small = ganjabush_rate/26
end

if GLOBAL.terrain.rooms.MeadowRocky then
	GLOBAL.terrain.rooms.MeadowRocky.contents.distributeprefabs.ganjabush_small = ganjabush_rate/42
end

if GLOBAL.terrain.rooms.MeadowMandrake then
	GLOBAL.terrain.rooms.MeadowMandrake.contents.distributeprefabs.ganjabush_small = ganjabush_rate/26
end

--### HAMLET BIOMES ###--

if GLOBAL.terrain.rooms.BG_plains_base then
	GLOBAL.terrain.rooms.BG_plains_base.contents.distributeprefabs.ganjabush_small = ganjabush_rate/26
end

if GLOBAL.terrain.rooms.plains_tallgrass then
	GLOBAL.terrain.rooms.plains_tallgrass.contents.distributeprefabs.ganjabush_small = ganjabush_rate/26
end

if GLOBAL.terrain.rooms.plains_ruins then
	GLOBAL.terrain.rooms.plains_ruins.contents.distributeprefabs.ganjabush_small = ganjabush_rate/26
end

if GLOBAL.terrain.rooms.plains_pogs then
	GLOBAL.terrain.rooms.plains_pogs.contents.distributeprefabs.ganjabush_small = ganjabush_rate/28
end

if GLOBAL.terrain.rooms.plains_base_nobatcave then
	GLOBAL.terrain.rooms.plains_base_nobatcave.contents.distributeprefabs.ganjabush_small = ganjabush_rate/36
end

-- Ganja Bush will not spawn on a terrain tile of the types in the list provided
GLOBAL.terrain.filter.ganjabush_small = 
	{GLOBAL.GROUND.ROAD, 
	GLOBAL.GROUND.WOODFLOOR, 
	GLOBAL.GROUND.CARPET, 
	GLOBAL.GROUND.CHECKER}

--## We will keep this to use later, to add again the set piece in SW ##--

--Check if SW is installed to spawn the set piece.

--[[if SW_ENABLED then 
	GLOBAL.require("map/tasks")

	-- For SW spawn the setpiece. (adapted from lagoon setpiece mod)	
	
	local Layouts = GLOBAL.require("map/layouts").Layouts
	local StaticLayout = GLOBAL.require("map/static_layout")
	Layouts["ganjabush_setpiece"] = StaticLayout.Get("map/static_layouts/ganjabush_setpiece")

	--[NEW] Here we define a new room containing one 'ganjabush_setpiece'.  Ignore the colour and value parameters.
	AddRoom("ganjabush_setpiece", 
		{
			colour = {r=0.3,g=0.2,b=0.1,a=0.3},
			value = GLOBAL.GROUND.BEACH, 
			contents =  
			{
				countstaticlayouts = {ganjabush_setpiece = 1},
				distributepercent = 1,
				distributeprefabs = {}
			}
		})
	
	local isle_task = GLOBAL.tasks.GetTaskByName("IslandCasino", GLOBAL.tasks.sampletasks)
	isle_task.room_choices["ganjabush_setpiece"] = 1
end]]