--This script creates and defines the cigarette prefab
------------------------------------------------------
local assets =
{
    Asset("ANIM", "anim/cigarette.zip"),
    Asset("ATLAS", "images/inventoryimages/cigarette.xml"),
    Asset("IMAGE", "images/inventoryimages/cigarette.tex"),
}


local function onfinished(tok, stoner, inst)
    inst.components.stackable:Get(1):Remove()
end

local function fn(Sim)

    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("cigarette")
    inst.AnimState:SetBuild("cigarette")
    inst.AnimState:PlayAnimation("idle_loop")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "cigarette"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/cigarette.xml"

    inst:AddTag("cigarette")

	inst:AddComponent("fuel") --DS port
	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)
	
    inst:AddComponent("tokeable")
    inst.components.tokeable.OnToke = onfinished

    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = 20

    return inst
end

return Prefab("common/inventory/cigarette", fn, assets)

