--######GANJA######--

--These are basically the custom animations and graphics that we're loading for the prefab
local assets=
{
	Asset("ANIM", "anim/ganja.zip"),
	Asset("ATLAS", "images/inventoryimages/ganja.xml"),
	Asset("ANIM", "anim/meat_rack.zip"),

}

--Loads any custom prefabs we're going to reference
local prefabs =
{
	"ganja_seeds",		--Need this in order to turn weed into ganja_seeds
	"spoiled_food", 	--Need this in order to make weed into something spoiled.
	"poopcloud",        -- Need this in order to make the poopcloud in the fire.
}

local dried_assets =
{	

	Asset("ANIM", "anim/ganja_dried.zip"),
	Asset("ATLAS", "images/inventoryimages/ganja_dried.xml"),

}

local dried_prefabs =
{
	"ganja_seeds",
	"spoiled_food",
	"poopcloud",
}

--  ### This function is to make the smoke when throw ganja in the fire ###
local function FuelTaken(inst, taker)
	if taker:HasTag("cooker") then -- Need this to only use smoke when fueling the firepit, not the pipe.
    SpawnPrefab("poopcloud").Transform:SetPosition(taker.Transform:GetWorldPosition())
	
	elseif taker:HasTag("tuskpipe") then -- We will need this to set the diferent boosts from toking tusk pipe with ganja
		if inst:HasTag("ganja") then
			taker:AddTag("ganja")
		elseif inst:HasTag("ganja_dried") then
			taker:AddTag("ganja_dried")
		end
	end	
end

local function common(bank, build, anim, tags, dryable, cookable) -- Needed to create this way to accept on drying rack.
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    
    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank(bank)
    inst.AnimState:SetBuild(build)
    inst.AnimState:PlayAnimation(anim)
	
	if dryable ~= nil then
        inst:AddComponent("dryable")
        inst.components.dryable:SetProduct(dryable.product)
        inst.components.dryable:SetDryTime(dryable.time)
    end
	
	inst:AddComponent("edible")  -- we used this to set the green background in inventory while it spoils.
	inst.components.edible.healthvalue = 0 -- we dont want any buff from eating.
    inst.components.edible.hungervalue = 0
	
	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_SUPERSLOW) -- = Same spoil time as honey.
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"
	
	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM -- = 40 itens
	
	inst:AddComponent("inspectable")
	
	inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.TINY_FUEL
    inst.components.fuel:SetOnTakenFn(FuelTaken)        --### Use the function that make "smoke" (poopcloud) ###--
	
	MakeSmallBurnable(inst) -- To make it burn
	MakeSmallPropagator(inst) -- To make it propagate the fire to other prefabs
	
	return inst
end

local function ganja_dried()
    local inst = common("ganja_dried", "ganja_dried", "idle_loop")
	
	inst:AddTag("ganja_dried")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_SUPERSLOW) -- = Same spoil time as honey.
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/ganja_dried.xml"
	
	return inst
end

local function ganja()
	local inst = common("ganja", "ganja", "idle_loop", nil, { product = "ganja_dried", time = TUNING.DRY_FAST }, nil)
	
	inst:AddTag("ganja")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_PRESERVED) -- = Same spoil time as honey/2
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/ganja.xml"	
	return inst
end

return Prefab( "ganja", ganja, assets, prefabs),
	   Prefab("ganja_dried", ganja_dried, dried_assets, dried_prefabs)