            --#### GANJA SEEDS SW ####--
------------------------------------------------------

require "prefabutil"

local assets =
{
	Asset("ATLAS", "images/inventoryimages/ganja_seeds.xml"),
	Asset("ANIM", "anim/ganja_seeds.zip"),
}


local prefabs =
{
	"ganja_seeds",
	"spoiled_food",
	"ganjabush_sapling",
} 

--Tests the ground to determine if the seed can be planted where the person is trying to place it
local notags = {'NOBLOCK', 'player', 'FX'}

local function test_ground(inst, pt)

	local tiletype = GetGroundTypeAtPosition(pt)
	local ground_OK = tiletype ~= GROUND.ROCKY 
	
	and tiletype ~= GROUND.ROAD 
	and tiletype ~= GROUND.IMPASSABLE 
	and tiletype ~= GROUND.UNDERROCK 
	and tiletype ~= GROUND.WOODFLOOR 
	and tiletype ~= GROUND.CARPET
	and tiletype ~= GROUND.CHECKER 
	--SW GROUNDS
	and tiletype ~= GROUND.BEACH
	and tiletype ~= GROUND.OCEAN_SHORE
	and tiletype ~= GROUND.OCEAN_SHALLOW
	and tiletype ~= GROUND.OCEAN_MEDIUM
	and tiletype ~= GROUND.OCEAN_DEEP
	and tiletype ~= GROUND.OCEAN_CORAL_SHORE
	and tiletype ~= GROUND.FLOOD
	and tiletype ~= GROUND.MARSH
	and tiletype ~= GROUND.MANGROVE_SHORE
	--HAMLET GROUNDS
	and tiletype ~= GROUND.COBBLEROAD
	and tiletype ~= GROUND.INTERIOR
	and tiletype ~= GROUND.FOUNDATION
	--and tiletype ~= GROUND.LAWN
	
	and tiletype < GROUND.UNDERGROUND
	
	--inst:IsPosSurroundedByLand(pt.x, pt.y, pt.z, 1)
	
	if ground_OK then
	    local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 4, nil, notags) -- or we could include a flag to the search?
		local min_spacing = inst.components.deployable.min_spacing or 2

	    for k, v in pairs(ents) do
			if v ~= inst and v:IsValid() and v.entity:IsVisible() and not v.components.placer and v.parent == nil then
				if distsq( Vector3(v.Transform:GetWorldPosition()), pt) < min_spacing*min_spacing then
					return false
				end
			end
		end
		return true
	end
	return false
end


local function OnDeploy (inst, pt) 
	local ganja_seeds = SpawnPrefab("ganjabush_sapling")
	if ganja_seeds then
		ganja_seeds.Transform:SetPosition(pt.x, pt.y, pt.z)
		--inst.AnimState:PlayAnimation("idle_loop")
		inst.components.stackable:Get():Remove()
		inst.Transform:SetScale(3,3,3)
	end
end

--------------------------------------------------------------------------

local function fn(Sim)
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()

	inst:AddTag("ganjaseeds")	
	MakeInventoryPhysics(inst)
	--inst:SetPrefabNameOverride("ganja seeds")
	inst.AnimState:SetBank("ganja_seeds")
	inst.AnimState:SetBuild("ganja_seeds")
	inst.AnimState:SetRayTestOnBB(true)
	inst.AnimState:PlayAnimation("idle_loop")

	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM -- =40 itens

	inst:AddComponent("inspectable")

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/ganja_seeds.xml"
	
	inst:AddComponent("edible") -- we used this to set the green background in inventory while it spoils.
	inst.components.edible.healthvalue = 0
    inst.components.edible.hungervalue = 0
	
	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_SUPERSLOW) -- Same as honey spoil time
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"
	
	inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.TINY_FUEL
	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)

	
	inst:AddComponent("deployable")
	inst.components.deployable.test = test_ground
	inst.components.deployable.ondeploy = OnDeploy
	

	return inst
end

return Prefab("common/objects/ganja_seeds", fn, assets),
		MakePlacer("common/objects/ganja_seeds_placer", "ganjabush", "ganjabush_sapling", "idle_sapling")
