--######## GANJA BUSH #########--


local assets =
{
	Asset("ANIM", "anim/idle_full.zip"),
	Asset("ANIM", "anim/grow_full_to_old.zip")
}

local prefabs =
{
    "ganja",
    "ganja_seeds",
    "twigs"
}

local function dig_up_bush(inst)
	local pt = inst:GetPosition() -- need this in order to run SpawnLootPrefab
		inst.components.lootdropper:SpawnLootPrefab("twigs")
		inst.components.lootdropper:SpawnLootPrefab("ganja_seeds")
		inst.components.lootdropper:SpawnLootPrefab("ganja")
		inst.components.lootdropper:SpawnLootPrefab("ganja")
		inst.components.lootdropper:SpawnLootPrefab("ganja")
		inst.components.lootdropper:SpawnLootPrefab("ganja")
		inst.components.lootdropper:SpawnLootPrefab("ganja")
		inst:Remove()
end


local function now_become(inst)
	local x, y, z = inst.Transform:GetWorldPosition()
	SpawnPrefab("ganjabush_old").Transform:SetPosition(x, y, z)
	inst:Remove()
end

local function now_grow(inst)
	local pt = inst:GetPosition()
	inst.AnimState:SetBank("ganjabush")
	inst.AnimState:SetBuild("grow_full_to_old")
	inst.AnimState:PlayAnimation("grow_full_to_old")
	inst.SoundEmitter:PlaySound("dontstarve/forest/treeWilt")
	inst:DoTaskInTime(1, now_become)
end

local function fn(Sim)
	local inst = CreateEntity()

	local stime = math.random(4200, 6400)

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon("ganjabush.tex")
	
	MakeObstaclePhysics(inst, .15) --##OFFICIAL GANJABUSH SIZE ##--
	
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.DIG)
	inst.components.workable:SetWorkLeft(1)
	inst.components.workable:SetOnFinishCallback(dig_up_bush) -- call function dig_up_bush when you dig.

	inst:AddComponent("inspectable")
	inst:AddComponent("lootdropper")

	inst.AnimState:SetBank("ganjabush")
	inst.AnimState:SetBuild("idle_full")
	inst.AnimState:PlayAnimation("idle_full", true)
	inst:DoTaskInTime(stime, now_grow)
	
	inst:AddComponent("fuel") --DS port
	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)
	
	return inst
end

return Prefab("ganjabush_full", fn, assets, prefabs)

-------------------------------------------------------------------
