--######## GANJA BUSH #########--


local assets =
{
	Asset("ANIM", "anim/idle_old.zip")
}

local prefabs =
{
    "ganja_seeds",
    "twigs"
}

local function dig_up_bush(inst)
	local whichloot = math.random(1, 4)
	local pt = inst:GetPosition() -- need this in order to run SpawnLootPrefab
	if whichloot == 4 then
		inst.components.lootdropper:SpawnLootPrefab("twigs")
		inst.components.lootdropper:SpawnLootPrefab("ganja_seeds")
		inst.components.lootdropper:SpawnLootPrefab("ganja_seeds")
		inst:Remove()
	else
		inst.components.lootdropper:SpawnLootPrefab("twigs")
		inst.components.lootdropper:SpawnLootPrefab("ganja_seeds")
		inst:Remove()
	end
end


local function fn(Sim)
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon("ganjabush.tex")
	
	MakeObstaclePhysics(inst, .15) --##OFFICIAL GANJABUSH SIZE ##--
	
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.DIG)
	inst.components.workable:SetWorkLeft(1)
	inst.components.workable:SetOnFinishCallback(dig_up_bush) -- call function dig_up_bush when you dig.

	inst:AddComponent("inspectable")
	inst:AddComponent("lootdropper")

	inst.AnimState:SetBank("ganjabush")
	inst.AnimState:SetBuild("idle_old")
	inst.AnimState:PlayAnimation("idle_old", true)
	
	inst:AddComponent("fuel") --DS port
	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)
	
	return inst
end

return Prefab("ganjabush_old", fn, assets, prefabs) 

-------------------------------------------------------------------
