--######## GANJA BUSH #########--


local assets =
{
    	Asset("ANIM", "anim/idle_sapling.zip"),
	Asset("ANIM", "anim/grow_sapling_to_small.zip")
}

local prefabs =
{
    "ganjabush_small",
    "twigs"
}

local function dig_up_bush(inst)
	local pt = inst:GetPosition() -- need this in order to run SpawnLootPrefab
	inst.components.lootdropper:SpawnLootPrefab("twigs")
	inst:Remove()
end

local function now_become(inst)
	local x, y, z = inst.Transform:GetWorldPosition()
	SpawnPrefab("ganjabush_small").Transform:SetPosition(x, y, z)
	inst:Remove()
end

local function now_grow(inst)
	local pt = inst:GetPosition()
	inst.AnimState:SetBank("ganjabush")
	inst.AnimState:SetBuild("grow_sapling_to_small")
	inst.AnimState:PlayAnimation("grow_sapling_to_small")
	inst.SoundEmitter:PlaySound("dontstarve/wilson/harvest_berries")
	inst:DoTaskInTime(1, now_become)
end

local function fn(Sim)
	local inst = CreateEntity()

	local stime = math.random(1600, 2400)

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon("ganjabush.tex")
	
	MakeObstaclePhysics(inst, .15) --##OFFICIAL GANJABUSH SIZE ##--
	
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.DIG)
	inst.components.workable:SetWorkLeft(1)
	inst.components.workable:SetOnFinishCallback(dig_up_bush) -- call function dig_up_bush when you dig.

	inst:AddComponent("inspectable")
	inst:AddComponent("lootdropper")

	inst.AnimState:SetBank("ganjabush")
	inst.AnimState:SetBuild("idle_sapling")
	inst.AnimState:PlayAnimation("idle_sapling", true)
	inst:DoTaskInTime(stime, now_grow)
	
	inst:AddComponent("fuel") --DS port
	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)
	
	return inst
end

return Prefab("ganjabush_sapling", fn, assets, prefabs) 

-------------------------------------------------------------------
