--######## GANJA BUSH SMALL #########--


local assets =
{
	Asset("ANIM", "anim/idle_small.zip")
}

local prefabs =
{
    "ganja_seeds",
    "twigs"
}

local function dig_up_bush(inst)
	local pt = inst:GetPosition() -- need this in order to run SpawnLootPrefab
	inst.components.lootdropper:SpawnLootPrefab("twigs")
	inst.components.lootdropper:SpawnLootPrefab("ganja_seeds")
	inst:Remove()
end


local function now_grow(inst)
	local x, y, z = inst.Transform:GetWorldPosition()
	SpawnPrefab("ganjabush_med").Transform:SetPosition(x, y, z)
	inst:Remove()
end

local function fn(Sim)
	local inst = CreateEntity()

	local stime = math.random(2400, 3200)

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon("ganjabush.tex")
	
	MakeObstaclePhysics(inst, .15) --##OFFICIAL GANJABUSH SIZE ##--
	
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.DIG)
	inst.components.workable:SetWorkLeft(1)
	inst.components.workable:SetOnFinishCallback(dig_up_bush) -- call function dig_up_bush when you dig.

	inst:AddComponent("inspectable")
	inst:AddComponent("lootdropper")

	inst.AnimState:SetBank("ganjabush")
	inst.AnimState:SetBuild("idle_small")
	inst.AnimState:PlayAnimation("idle_small", true)
	inst:DoTaskInTime(stime, now_grow)
	
	inst:AddComponent("fuel") --DS port
	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)
	
	return inst
end

return Prefab("ganjabush_small", fn, assets, prefabs)

-------------------------------------------------------------------
