		-- ###### GOLDEN PIPE ###### --


--These are basically the custom animations and graphics that we're loading for the prefab

local assets =
{
  	Asset("ANIM", "anim/goldenpipe.zip"),
   	Asset("ATLAS", "images/inventoryimages/goldenpipe.xml"),
   	Asset("IMAGE", "images/inventoryimages/goldenpipe.tex"),
}

--This function defines the pipe.
--I have no idea what the "Sim" variable inside the function is used for.
local function fn(Sim)

    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    	
	MakeInventoryPhysics(inst)
    
	--Set the bank to "pipe" (goldenpipe.zip) set the build to "goldenpipe" and play the animation named "idle_loop""
	inst.AnimState:SetBank("goldenpipe")
    inst.AnimState:SetBuild("goldenpipe")
    inst.AnimState:PlayAnimation("idle_loop")
	
	--Make the item inspectable
    inst:AddComponent("inspectable")
	
	--Make the item something that can be put in your inventory
	inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "goldenpipe"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/goldenpipe.xml"
	
	--Not sure if we still need this but I haven't tested. Might be required for playing horn animation.
    inst:AddTag("goldenpipe")

	--Same as the tag. Might be neccessary for horn animation and/or HORN tuning paramaters below.
    --inst:AddComponent("instrument")
	 
	--This is our custom "tokeable" component 
    
    inst:AddComponent("tokeable")

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(12)
    inst.components.finiteuses:SetUses(12)
    inst.components.finiteuses:SetOnFinished(inst.Remove) 
    inst.components.finiteuses:SetConsumption(ACTIONS.TOKE, 1)
    return inst
end

--Creates the prefab named "pipe" using the methods/variables defined in the "fn" function and the assets defined in Assets
return Prefab("common/inventory/goldenpipe", fn, assets)

