--######HASH######--

--These are basically the custom animations and graphics that we're loading for the prefab
local assets=
{
	Asset("ANIM", "anim/hash.zip"),
	Asset("ATLAS", "images/inventoryimages/hash.xml"),

}

--Loads any custom prefabs we're going to reference
local prefabs =
{
	"poopcloud",        -- Need this in order to make the poopcloud in the fire.
}

--  ### This function is to make the smoke when throw hash in the fire ###
local function FuelTaken(inst, taker)
	if taker:HasTag("cooker") then -- Need this to only use smoke when fueling the firepit, not the pipe.
    SpawnPrefab("poopcloud").Transform:SetPosition(taker.Transform:GetWorldPosition())
	
	elseif taker:HasTag("tuskpipe") then -- We will need this to set the diferent boosts from toking tusk pipe with ganja and with hash.
			if inst:HasTag("hash") then
			taker:AddTag("hash")
		end
	end	
end

--This function defines the "hash" prefab.
local function hash()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)
	inst.AnimState:SetBank("hash")
	inst.AnimState:SetBuild("hash")
	inst.AnimState:PlayAnimation("idle_loop")
	
	inst:AddTag("hash")
    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM -- = 40 itens

	inst:AddComponent("inspectable")
	inst:AddComponent("tradable")
	inst.components.tradable.goldvalue = 1
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/hash.xml"

	inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.TINY_FUEL
    inst.components.fuel:SetOnTakenFn(FuelTaken)        --### Use the function that make "smoke" (poopcloud) ###--
	
	MakeSmallBurnable(inst) -- To make it burn
	MakeSmallPropagator(inst) -- To make it propagate the fire to other prefabs

	return inst
end

return Prefab( "hash", hash, assets, prefabs)
