--This script creates and defines the hashroll prefab
------------------------------------------------------
local assets =
{
    Asset("ANIM", "anim/hashroll.zip"),
    Asset("ATLAS", "images/inventoryimages/hashroll.xml"),
    Asset("IMAGE", "images/inventoryimages/hashroll.tex"),
}


local function onfinished(tok, stoner, inst)
    inst.components.stackable:Get(1):Remove()
end

local function fn(Sim)

    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("hashroll")
    inst.AnimState:SetBuild("hashroll")
    inst.AnimState:PlayAnimation("idle_loop")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "hashroll"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/hashroll.xml"

    inst:AddTag("hashroll")
	
	inst:AddComponent("fuel") --DS port
	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)
	
    inst:AddComponent("tokeable")
    inst.components.tokeable.OnToke = onfinished

    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    return inst
end

return Prefab("common/inventory/hashroll", fn, assets)

