--This script creates and defines the joint prefab
------------------------------------------------------
local assets =
{
    Asset("ANIM", "anim/joint.zip"),
    Asset("ATLAS", "images/inventoryimages/joint.xml"),
    Asset("IMAGE", "images/inventoryimages/joint.tex"),
}


local function onfinished(tok, stoner, inst)
    inst.components.stackable:Get(1):Remove()
end

local function fn(Sim)

    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("joint")
    inst.AnimState:SetBuild("joint")
    inst.AnimState:PlayAnimation("idle_loop")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "joint"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/joint.xml"

    inst:AddTag("joint")
	
    inst:AddComponent("tokeable") 
    inst.components.tokeable.OnToke = onfinished

    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
	
	inst:AddComponent("fuel") --DS port
	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)

    return inst
end

return Prefab("common/inventory/joint", fn, assets)

