		-- ###### TUSK PIPE ###### --


--These are basically the custom animations and graphics that we're loading for the prefab

local assets =
{
  	Asset("ANIM", "anim/tuskpipe.zip"),
   	Asset("ATLAS", "images/inventoryimages/tuskpipe.xml"),
   	Asset("IMAGE", "images/inventoryimages/tuskpipe.tex"),
}

local prefabs = {"ganja", "hash", "ganja_dried"}

local function onfinished(tok, stoner, inst) --Afeter using the "toke"
	inst.components.fueled:DoDelta(-1)
	inst.components.fueled.accepting = true
end

local function when_is_full(inst) -- Used to stop acpeting fuel when its full
	if inst.components.fueled:GetPercent() == 1 then
		inst.components.fueled.accepting = false
	end
end


local function takefuel(inst)
	inst:AddComponent("tokeable")
	inst.components.tokeable.OnToke = onfinished
	inst.components.fueled:DoDelta(1)
	when_is_full(inst)
end
			
		
local function nofuel(inst)
	  inst:RemoveComponent("tokeable")
      inst.components.fueled.accepting = true
end

	

local function fn(Sim)

    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    	
	MakeInventoryPhysics(inst)
    
	--Set the bank to "tuskpipe" (tuskpipe.zip) set the build to "tuskpipe" and play the animation named "idle_loop""
	inst.AnimState:SetBank("tuskpipe")
    inst.AnimState:SetBuild("tuskpipe")
    inst.AnimState:PlayAnimation("idle_loop")
	
	--Make the item inspectable
	inst:AddComponent("inspectable")
	
	--Make the item something that can be put in your inventory
	inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "tuskpipe"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/tuskpipe.xml"
	
	--Need this to set the animation and used by the toke action.
    inst:AddTag("tuskpipe")
	 
	--This is our custom "tokeable" component 
    
	inst:AddComponent("tokeable")

	inst.components.tokeable.OnToke = onfinished
	
	inst:RemoveComponent("tokeable")
	
	inst:AddComponent("fueled")
    inst.components.fueled:InitializeFuelLevel(1)
	inst.components.fueled:MakeEmpty()
    inst.components.fueled.CanAcceptFuelItem = function (inst, item) return item.prefab == "ganja"  or item.prefab == "ganja_dried" or item.prefab == "hash" end
    inst.components.fueled.accepting = true
	
	inst.components.fueled.ontakefuelfn = takefuel -- This is diferent in DST.
	inst.components.fueled:SetDepletedFn(nofuel)
	
	
    return inst
end

--Creates the prefab named "tuskpipe" using the methods/variables defined in the "fn" function and the assets defined in Assets
return Prefab("common/inventory/tuskpipe", fn, assets)

