--This script creates and defines the pipe prefab
------------------------------------------------------


--These are basically the custom animations and graphics that we're loading for the prefab

local assets =
{
  	Asset("ANIM", "anim/woodenpipe.zip"),
   	Asset("ATLAS", "images/inventoryimages/woodenpipe.xml"),
   	Asset("IMAGE", "images/inventoryimages/woodenpipe.tex"),
}

--This function defines the pipe.
--I have no idea what the "Sim" variable inside the function is used for.
local function fn(Sim)

    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    	
	MakeInventoryPhysics(inst)
    
	--Set the bank to "pipe" (woodenpipe.zip) set the build to "woodenpipe" and play the animation named "idle_loop"
	inst.AnimState:SetBank("woodenpipe")
    inst.AnimState:SetBuild("woodenpipe")
    inst.AnimState:PlayAnimation("idle_loop")
	
	--Make the item inspectable
    inst:AddComponent("inspectable")
	
	--Make the item something that can be put in your inventory
	inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "woodenpipe"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/woodenpipe.xml"
	
	--Not sure if we still need this but I haven't tested. Might be required for playing horn animation.
    inst:AddTag("woodenpipe")

	--Same as the tag. Might be neccessary for horn animation and/or HORN tuning paramaters below.
    --inst:AddComponent("instrument")
	 
	--This is our custom "tokeable" component 
    inst:AddComponent("fuel") --DS port
	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)
   
	inst:AddComponent("tokeable")


    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(4)
    inst.components.finiteuses:SetUses(4)
    inst.components.finiteuses:SetOnFinished(inst.Remove) 
    inst.components.finiteuses:SetConsumption(ACTIONS.TOKE, 1)
    return inst
end

--Creates the prefab named "pipe" using the methods/variables defined in the "fn" function and the assets defined in Assets
return Prefab("common/inventory/woodenpipe", fn, assets)

