local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action
local ActionHandler = GLOBAL.ActionHandler
local STRINGS = GLOBAL.STRINGS


local SpawnPrefab = GLOBAL.SpawnPrefab
local TheCamera = GLOBAL.TheCamera --*

local State = GLOBAL.State
local TimeEvent = GLOBAL.TimeEvent
local EventHandler = GLOBAL.EventHandler
local FRAMES = GLOBAL.FRAMES
local action = GLOBAL.Action

local function smoke(inst)
    local smoke = SpawnPrefab("poopcloud")
	local x, y, z = inst.Transform:GetWorldPosition()
	smoke.Transform:SetPosition(x, y+2.5, z)
end


local TOKE = Action({},3)
TOKE.str = "Toke"
TOKE.id = "TOKE"
TOKE.fn = function(act)
	if act.invobject.components.tokeable then
		act.invobject.components.tokeable:toke_item(act.doer, act.invobject)
		return true
	end
end

AddAction(TOKE)
GLOBAL.ACTIONS.TOKE = TOKE

local tokeing = State({

    name = "tokeing",
    
    tags = { "doing", "playing" },

    
    onenter = function(inst)
    inst.components.locomotor:Stop()
    inst.AnimState:PlayAnimation("horn")
	inst.AnimState:OverrideSymbol("horn01", toke_anim, "horn01")
	inst.AnimState:Show("ARM_normal")
	
    end,

        
        timeline =
        {
        TimeEvent(42*FRAMES, function(inst)
            inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel")
			smoke(inst)

            inst:PerformBufferedAction()
            end),
        },

        
        events =
        {
        EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            
            end),
        },

        
        onexit = function(inst)
        if inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS) then
            inst.AnimState:Show("ARM_carry") 
            inst.AnimState:Hide("ARM_normal")
        end
        end,
        })

AddStategraphState("wilson", tokeing)




AddStategraphActionHandler("wilson", ActionHandler(TOKE, function(inst, action)
    if action.invobject then
            if action.invobject:HasTag("joint") then
                toke_anim = "toke_joint" 
				return "tokeing"
			elseif action.invobject:HasTag("woodenpipe") then
				toke_anim = "toke_woodenpipe"
				return "tokeing"
			elseif action.invobject:HasTag("goldenpipe") then
				toke_anim = "toke_goldenpipe"
				return "tokeing"
			elseif action.invobject:HasTag("tuskpipe") then
				toke_anim = "toke_tuskpipe"
				return "tokeing"
			--[[elseif action.invobject:HasTag("chillum") then
				toke_anim = "toke_chillum"
				return "tokeing" ]]
			elseif action.invobject:HasTag("cigarette") then
				toke_anim = "toke_cigarette"
				return "tokeing"
			elseif action.invobject:HasTag("hashroll") then
				toke_anim = "toke_cigarette"
				return "tokeing"
			else
				return
			end
        end
        end)
)

